﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Globalization;

namespace GpsSample
{
    internal static class Utility
    {
        /// <summary>
        /// Builds a query string from string dictionary key value pairs.
        /// </summary>
        /// <param name="query">The query.</param>
        /// <returns></returns>
        internal static string BuildQueryString(Dictionary<string, string> query)
        {
            // Too bad the compact framework doesn't support all generic type and linq features.

            //return string.Join("&", Array.ConvertAll<string, string>(query.Keys.ToArray(),
            //    (key) => {
            //        return string.Format("{0}={1}", key, query[key]);
            //    }));

            string[] parameters = new string[query.Keys.Count];
            int count = 0;

            foreach (var key in query.Keys)
            {
                parameters[count++] = string.Format("{0}={1}", key, query[key]);
            }

            return string.Join("&", parameters);
        }

    }
}
